/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


                      Apache ServiceMix 3.2
                      =====================

See the README file for more general informations about ServiceMix.


ServiceMix URLs:
----------------
Home Page:     http://servicemix.apache.org/
Downloads:     http://servicemix.apache.org/download.html
Documentation: http://servicemix.apache.org/documentation.html
Mailing Lists: http://servicemix.apache.org/mailing-lists.html
Source Code:   http://servicemix.apache.org/source.html
Bug Tracking:  http://issues.apache.org/activemq/browse/SM

Changes:
--------

**Sub-task

    * [SM-652] - org.apache.servicemix.eip.StaticRoutingSlipTxTest
    * [SM-653] - org.apache.servicemix.eip.WireTapJmsFlowTest
    * [SM-654] - org.apache.servicemix.eip.PipelineTxTest
    * [SM-655] - org.apache.servicemix.eip.SplitAggregatorTxTest
    * [SM-657] - org.apache.servicemix.eip.MessageFilterTxTest
    * [SM-658] - org.apache.servicemix.eip.WireTapTxTest
    * [SM-659] - org.apache.servicemix.eip.XPathSplitterTxTest
    * [SM-660] - org.apache.servicemix.eip.DeploymentTest
    * [SM-661] - org.apache.servicemix.eip.support.NamespaceContextImplTest
    * [SM-662] - org.apache.servicemix.eip.SpringConfigurationTest
    * [SM-663] - org.apache.servicemix.eip.ContentBasedRouterTxTest
    * [SM-899] - org.apache.servicemix.file.SpringComponentTest fails with java.lang.IllegalStateException

**Bug

    * [SM-331] - JabberComponentSupport attempts to create a jabber account every time on start
    * [SM-470] - servicemix-http has no way to set a soap action
    * [SM-750] - ClientFactory should implement java.io.Serializable
    * [SM-828] - OutBinding doesn't allow for DeliveryChannel.accept()
    * [SM-829] - Incorrect file encoding of created jbi.xml
    * [SM-832] - Ws-Security signature does not work for outbound
    * [SM-833] - into loan-broker-bpel sample - javax.jbi.messaging.MessagingException: Do not understand pattern: null
    * [SM-835] - achetypes should not contain the <classpath/> tag inside the spring files
    * [SM-839] - java.lang.IllegalStateException: Could not find valid implementation for: 2.0
    * [SM-840] - JMS connections not close in servicemix-wsn2005
    * [SM-841] - The servicemix-http provider endpoint does not properly handle web services that return faults with multiple elements in the detail section.
    * [SM-842] - AuthenticationService set on the configuration is not used
    * [SM-843] - The defaultMep attribute is missing on the jms endpoint in loan-broker-bpel demo
    * [SM-845] - servicemix-quartz includes unneeded spring libraries
    * [SM-846] - Call to default constructor of JBIContainer changes log4j log level
    * [SM-847] - Old version of xml-apis in distribution
    * [SM-849] - The web console fails when displaying an error
    * [SM-850] - Error starting ServiceMix on AIX
    * [SM-853] - NPE in DotViewFlowListener
    * [SM-854] - LogService uses hard-coded path to the log4j.xml file
    * [SM-858] - Unable to access a JBIContainer using the supplied component context in various endpoints (i.e. JSR181)
    * [SM-860] - EndpointReferenceBuilder.getReference() should cache its DocumentBuilderFactory instance
    * [SM-861] - servicemix-common does not properly set the correlationId for exchanges that are sent using sendSync
    * [SM-862] - Possible problem when @WebMethod returns an empty string for the operation name
    * [SM-863] - Generated ids are too long, it may cause problems when using them in databases as indexes
    * [SM-866] - wsn-http-binding fails to start
    * [SM-867] - Cannot add soap header in JSR181 component
    * [SM-873] - servicemix-http does not return a valid fault when the xml is invalid
    * [SM-874] - servicemix-http does not honor the soap version for certain kinds of faults
    * [SM-878] - servicemix-bean is not include in the distribution
    * [SM-879] - EIP XPath Splitter and Drools3.1 used together cause problems in xpath evaluation
    * [SM-890] - Security Subject can not be propagated in servicemix-jsr181 when using the jsr181 proxies
    * [SM-891] - Maven plugin should use finalName
    * [SM-892] - ManagementContext.shutdown() calls wrong method to unregister MBeans
    * [SM-893] - Messages lost under heavy load using JMSFlow
    * [SM-895] - HttpConsumerEndpoint, security issue
    * [SM-898] - soap2 unit tests fail with NullPointerException
    * [SM-900] - WSDLFlattenner does not handle schemas inclusions
    * [SM-902] - File Binding example error with JaxenStringXPathExpression
    * [SM-904] - The jmx url is wrong if there are spaces at the end of the properties
    * [SM-911] - JDBCComponent: The first column index is 1 in a result from sql query (non zero)
    * [SM-914] - Exception upon generating a dot file from the apache-servicemix-web distribution in Tomcat
    * [SM-921] - FTPClientPool does not have dataTimeout and controlEncoding properties.
    * [SM-923] - NPE in the web console when viewing component with lightweight components deployed
    * [SM-928] - ProviderProcessor leaks memory for https endpoints
    * [SM-930] - ComponentListener does not get notified on Component uninstall
    * [SM-931] - PMD/CheckStyle errors for servicemix-eip
    * [SM-937] - Poller polls subdirectory even though recursive is set to false
    * [SM-938] - Component updates (from the hot deployer) sometimes fail
    * [SM-940] - OneWay operation are not supported
    * [SM-941] - NPE in BeanComponent - checkEndOfRequest
    * [SM-944] - IllegalStateException between servicemix-jms and servicemix-bean
    * [SM-945] - ConsumerProcessor error when find KeyStore ("server.keyStore")
    * [SM-951] - Remove servicemix-sca which is hosted in tuscany and which is completely outdated
    * [SM-952] - ClassLoaderXmlPreprocessor not able to load shared libraries from xbean.xml
    * [SM-959] - ssl truststore is not set for unmanaged
    * [SM-960] - JSR181 Orchestration sample doesn't work (Current state not START_ELEMENT, END_ELEMENT or ENTITY_REFERENCE )
    * [SM-963] - NullPointerExceptions during JMS component initialization
    * [SM-966] - Consumer Endpoint sets service/interface/uri on the message exchange while it has been already set earlier
    * [SM-969] - JBIMarshaler doesn't copy Subject from NormalizedMessage to SoapMessage
    * [SM-972] - authenticationService is null - Several SA deployed on the same instance of Smx
    * [SM-977] - wsdl-first example fails: XFireFault (could not unmarshal type)
    * [SM-981] - Transaction Exception due to ServiceMix JMS Provider
    * [SM-982] - memory leak in org.apache.servicemix.bean.BeanEndpoint
    * [SM-987] - Binding Component archetype - can't build
    * [SM-991] - servicemix-saxon component lacks ServiceUnit analyzer which results in generating incomplete jbi.xml
    * [SM-996] - ServiceMix doesn't start correctly due to javax.management.MalformedObjectNameException: Invalid ObjectName value type [javax.xml.namespace.QName]: only ObjectName and String supported
    * [SM-998] - In-Out Exchanges in a JMS queue cannot be successfully processed after a crash/shutdown
    * [SM-1002] - Service mix hangs when the # concurrent requests exceeds the maxConnectionsPerHost
    * [SM-1004] - File poller deletes files, even if errors occur while processing
    * [SM-1006] - 0 byte files written when message contains invalid content
    * [SM-1011] - WSDLFlattenner / SchemaCollection do not handle nested schemas inclusions properly
    * [SM-1012] - Possible resource leak in FilePoller
    * [SM-1014] - WSDL-first example fails javax.jbi.messaging.MessagingException: Do not understand pattern: null
    * [SM-1016] - Environment Context ComponentMBeanImpl Removal
    * [SM-1020] - Invalid query.xq generated by servicemix-saxon-xquery-service-unit archetype
    * [SM-1021] - DOMException: NAMESPACE_ERR
    * [SM-1023] - correlationId and senderEndpoint properties are not set on jsr181 (using the proxy) and jms consumer endpoints
    * [SM-1024] - Archetype generates invalid brokerURL
    * [SM-1026] - CorrelationId and senderEndpoint properties are not setted on the lightweigth components using the TransformComponentSupport
    * [SM-1029] - Bug in HTTP BC when configuring managed keystore for SSL
    * [SM-1033] - WSDL-First example fails due to missing defaultMep attribute in wsdl-first-http-su's xbean.xml
    * [SM-1037] - Geronimo Plugin enhancement and bug fix
    * [SM-1038] - http provider endpoint sends wrong Host header
    * [SM-1042] - Build fails in Java 6: Cannot find symbol StandardMBean(Object, Class<?>)
    * [SM-1043] - Poller sends invalid MessageExchange when file has been deleted
    * [SM-1050] - Memory Leak in http consumer processor when using SSL
    * [SM-1061] - Race condition in RSS feed-writer component
    * [SM-1082] - Inconsistent exception handling in ClientFactory
    * [SM-1102] - The jbi maven plugin does not support jars packaged as bundles
    * [SM-1104] - Type converters not working in ServiceMix
    * [SM-1110] - ServiceMix is not sending a response back to the calling Service in an In-Out Message Exchange
    * [SM-1113] - SOAP faults don't work when elementFormDefault is unqualified
    * [SM-1114] - Encoding in soap requests is always 7bit

**Improvement

    * [SM-510] - The servicemix-jms component should support the ability to set jms message properties
    * [SM-555] - Improving reliability of servicemix-jms - servicemix looses messages when crashing
    * [SM-557] - WSDL 1.1 message normalization for the servicemix-http component
    * [SM-611] - Reduce non-optional core dependencies
    * [SM-761] - JRuby support
    * [SM-795] - HTTP headers attached as properties may cause requests to fail
    * [SM-807] - Add jboss-service.xml to servicemix component so they can be properly deployed in jboss.
    * [SM-830] - Replace System.out printing with logger
    * [SM-844] - Using Shared Libraries from LW SUs
    * [SM-865] - Remove jta and j2ee-connector from the mandatory dependencies when running an embedded ServiceMix instance
    * [SM-869] - Avoid creating xml factories in jsr181
    * [SM-870] - StaxSourceTransformer should reuse the XMLStreamReader when available
    * [SM-871] - Optimize wsdl-first example
    * [SM-876] - jmx.xml should use the jmx.url property
    * [SM-877] - Bottleneck in SoapReader.readSoapUsingDom()
    * [SM-885] - WSA Epr are not recognized for namespaces other than http://www.w3.org/2005/08/addressing
    * [SM-886] - Upgrade to saxon 9.9
    * [SM-887] - The default value for the result property should be set back to 'dom'
    * [SM-894] - Auto-create directory when file name contains subdirectories
    * [SM-896] - Add a currentState on the component and ensure endpoints are correctly added / started at runtime
    * [SM-903] - ServiceMix now requires java 5
    * [SM-906] - extend ComponentSupport with methods to propagate the correlation id
    * [SM-907] - Update to the latest version of the WS-Notification 1.3 spec
    * [SM-909] - Upgrade to Geronimo 2.0
    * [SM-912] - DOMStreamReader does not need to report namespaces as events
    * [SM-913] - Improve archetypes and add a batch file for ease of use
    * [SM-922] - When browsing for available services, existing urls should end with the needed '/' when displayed
    * [SM-924] - Namespace support in servicemix-drools
    * [SM-934] - change checkstyle line length to 140
    * [SM-943] - Use a Calendar that displays nicely for the MessageExchange timestamp property
    * [SM-965] - Allow use of -Dhost, -Dport, -Dusername and -Dpassword on jbi:projectDeploy
    * [SM-986] - The maven jbi plugin should not fail it the SU jbi descriptor generation fails but only displays a warning
    * [SM-990] - FilePoller with Archiving
    * [SM-1013] - All event interfaces should inherit a common one
    * [SM-1025] - Add an example of <eip:resequencer/> to the archetype's xbean.xml
    * [SM-1034] - Use a single hotdeploy directory, put components inside it, and start servicemix in the SERVICEMIX_HOME directory by default
    * [SM-1040] - flag for automatic validation of the payload by the ws engine
    * [SM-1048] - Camel InOut support
    * [SM-1049] - Raise the number of http requests that can be send concurrently by servicemix-http
    * [SM-1054] - Port JmsMarshaler from lightweight jms component to servicemix-jms component
    * [SM-1056] - Add NamespaceContextImpl to servicemix-core
    * [SM-1060] - cxf se should support ComponentContext and DeliveryChannel injection
    * [SM-1077] - CXFSE should allow a proxy to another CXFSE service like jsr181 does.
    * [SM-1078] - CXFSE xbean.xml should allow the injection of the spring parent context, just like JSR181
    * [SM-1081] - A StaticRecipientListAggregator like SplitAggregator is needed
    * [SM-1084] - make configurable if CONTENT-TYPE is used as property from the normalized message or not
    * [SM-1086] - Example of how to use CXFBC Provider.
    * [SM-1088] - CXFbc provider should provider a targetURI element
    * [SM-1094] - add type java.lang.String to the SimpleDestinationChooser.chooseDestination method
    * [SM-1109] - attachment should be supported in cxf se and bc

**New Feature

    * [SM-420] - Setting maximum memory
    * [SM-532] - Allow easier deployment of endpoints using servicemix-common by splitting components from endpoints and put all endpoints together
    * [SM-537] - Define several endpoint implementations instead of having only one
    * [SM-724] - able to write marshaller for JBI components
    * [SM-745] - Allow using Tibco for the JMSFlow
    * [SM-826] - Add client for loan-broker-bpel
    * [SM-834] - Provide File Marshalling for CSV/variable, fixed and heirarchial messages
    * [SM-851] - Better soap / wsdl support
    * [SM-856] - Add a marshaler to the servicemix-http component that handles Java serialization
    * [SM-875] - TrueZIP binding component
    * [SM-918] - Ability to reference Shared Libraries from Service Units
    * [SM-929] - eip message filter switch predicate where you can easily turn on/off the exchange flow depending on a property in a message filter
    * [SM-939] - CXF based Service Engine and Bnding Component
    * [SM-956] - Enhance jbi-maven-plugin to allow the use of a custom ServiceUnitAnalyzer
    * [SM-985] - Allow additional beans to be injected in the rules definition from the xbean.xml
    * [SM-989] - Backup File before Delete
    * [SM-995] - JmsProviderEndpoint in-out mode need to be implemented
    * [SM-1008] - Resequencer pattern for EIP component
    * [SM-1045] - Servicemix tooling changes to generate JBISharedLibraryDescriptor
    * [SM-1085] - Additional geronimo deployment plan support
    * [SM-1095] - Reference components classpath from SUs
    * [SM-1107] - Deploy endpoints and listeners through the lwcontainer

**Task

    * [SM-881] - Upgrade to xbean-spring 3.0
    * [SM-901] - Upgrade to xfire 1.2.5
    * [SM-932] - Enable PMD/CheckStyle for binding components
    * [SM-946] - Upgrade loan-broker-bpel example to use Apache Ode
    * [SM-978] - Provider side of the new HTTP endpoints
    * [SM-994] - Add target .classpath and .project to svn:ignore list
    * [SM-1009] - Create a code formatter profile for import into Eclipse
    * [SM-1028] - Ease the release process by avoiding manual changes in the source files

**Wish

    * [SM-897] - DefaultComponent, adding endpoints


